'
' Password v1   1996 Cadenza Software - Written by Matthew Bacon
'

DEFINT a-z
'$option K10

' Display initial screen, to let the user know a password is required
LOCATE 11,31:PRINT "Password:"
LOCATE 13,28:PRINT " 1996 Cadenza Software"
LOCATE 14,28:PRINT "Written by Matthew Bacon"

DO
' Read key pressed, make the letter upper casing
try$=UCASE$(INKEY$)

' Make sure a letter exists
IF NOT try$="" THEN
	try=ASC(try$)
	SELECT CASE try
		' If escape key was pressed, quit 
		CASE 27
			SYSTEM
		' If backspace key was pressed
		CASE 8
			DECR i
			IF i<0 THEN i=0:EXIT SELECT
			' Print to screen, password is masked
			LOCATE 11,31:PRINT "Password: "+STRING$ (i,ASC("*"))+" "
			password$=LEFT$(password$,LEN(password$)-1)
'			LOCATE 10,31:PRINT "Password: "+password$+" "
		' If return key was pressed, check against given password
		CASE 13
			' If the correct password has been given, quit
			IF password$="MATTY B" THEN EXIT LOOP
		' If one of the letter, numerical or spacebar keys was pressed
		CASE 32,65 TO 65+26,48 TO 57
			INCR i
			' i= no. of characters in password
			IF i>8 THEN i=8:EXIT SELECT
			' Print to screen, password is masked
			LOCATE 11,31:PRINT "Password: "+STRING$ (i,ASC("*"))
'			LOCATE 10,31:PRINT "Password: "+password$+try$
			password$=password$+try$
	END SELECT
END IF
LOOP
' Quit
SYSTEM
